﻿using UnityEngine;
using System.Collections;
using System;
using System.IO.Ports;
using System.Threading;

public class SerialHandler : MonoBehaviour
{
	public delegate void SerialDataReceivedEventHandler(string message);
	public event SerialDataReceivedEventHandler OnDataReceived;
	
	public string portName = "/dev/tty.usbserial-FTH83HVZ";
	public int baudRate    = 4800;
	
	private SerialPort serialPort_;
	private Thread thread_;
	private bool isRunning_ =  false;  
	 
	private string message_;
	
	private int data1=0; 
	private int data2=0; 
	private int data3=0; 
	private int data4=0; 
	private int data5=0; 
	private int data6=0; 
	private int data7=0; 
	private int data8=0; 
	private int data9=0; 
	private int data10=0; 
	private int total1=0; 
	private int total2=0; 
	private int total3=0; 

	private bool isNewMessageReceived_ = false;
	
	void Awake()
	{
		Open();      
	}  
	
	void Update()
	{  
		if(Input.GetKey(KeyCode.LeftArrow)){
			 
		}
		if (isNewMessageReceived_) {
 			//OnDataReceived(message_);
 			OnDataReceived(total1.ToString("g") + "a"+ total2.ToString("g") +"a"+ total3 .ToString("g"));
		}        
	}
	
	void OnDestroy()
	{
		Close();
	}
	 
	private void Open()
	{

    	serialPort_ = new SerialPort(portName, baudRate, Parity.None, 8, StopBits.One);
   		serialPort_.Open();   
		Debug.Log("open the port ");
		isRunning_ = true; 
		
		thread_ = new Thread(Read);
		thread_.Start();
	}
	 
	private void Close() 
	{
		isRunning_ = false;
		
		if (thread_ != null && thread_.IsAlive) {
			thread_.Join();
		}
		
		if (serialPort_ != null && serialPort_.IsOpen) {
			serialPort_.Close();
			serialPort_.Dispose();
		}
	}
	
	private void Read()
	{
		while (isRunning_ && serialPort_ != null && serialPort_.IsOpen) {
			try {
				if (serialPort_.BytesToRead > 0) {
					data10 = data9;  
					data9 = data8;  
					data8 = data7;  
					data7 = data6;  
					data6 = data5;  
					data5 = data4; 
					data4 = data3;
					data3 = data2;  
					data2 = data1; 
					data1 = serialPort_.ReadByte();
					//Debug.Log("data is coming" + data6 + ":"+ data5 + ":"+ data4 + ":"+ data3 + ":"+ data2 + ":"+ data1); 
					if((data10 == 1) && (data9== 2) && (data8== 3) && (data7== 4)){
						total1 = data6*256+data5;
						total2 = data4*256+data3;
						total3 = data2*256+data1;
						//Debug.Log("data is coming" + total);  
					}

					//message_ = serialPort_.ReadLine();
					//Debug.Log("Reading  port.  " +  data1);    
					isNewMessageReceived_ = true; 
				} 
			} catch (System.Exception e) {
				Debug.LogWarning(e.Message);
			}
		}
	}
	
	public void Write(string message)
	{
		try {
			serialPort_.Write(message);
		} catch (System.Exception e) {
			Debug.LogWarning(e.Message);
		}
	}
}   